Require Import Map.
Require Import TM.
Require Import Assertions.
Require Import SAGL.
Require Import AuxLib.
Require Import Arith.
Require Import Omega.



Lemma SAGL_Presv_aux_left:
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2,
  forall M T_1 T_2 L M' T_1' L',
    SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 (M, (T_1, T_2), L)
        -> ThrdStep (M, T_1, L) (M', T_1', L')
	-> exists a_1', exists v_1',
             SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1' v_1' a_2 v_2 (M', (T_1', T_2), L').
Proof.
  intros.
  unfold SAGL_WFprog in H.
  induction T_1 as [p tid_1].
  induction p as [p0 I_1].
  induction p0 as [C_1 R_1].
  induction T_2 as [p tid_2].
  induction p as [p0 I_2].
  induction p0 as [C_2 R_2].  
  InvertAll.
  rename x1 into M_1.
  rename x2 into M_2.
  rename x0 into Mx.
  rename x into Ms.
  unfold disjUnion in H1.
  unfold disjUnion in H3.
  InvertAll.
  assert (disjoint Ms M_1).
  apply disjoint_commut.
  apply disj_distr_left with M_2.
  rewrite <- H12. 
  auto.
  assert (disjoint Ms M_2).
  apply disjoint_commut.
  apply disj_distr_right with M_1.
  rewrite <- H12. auto.

  unfold SAGL_WFthrd in H4.
  InvertAll.
  induction I_1. 
  clear IHI_1.
  inversion H15.
  induction c.

  (* add *)  
  exists a'. exists v'.
  clear H4 H16 H17 H18.
  clear c0 I.
  inversion H0.
  rewrite <- H29.
  clear H4 H17 H18 H23 H24 H25 H26 H27 H28 H29.
  clear M0 C R c I k L0 M'0.
  inversion H16.
  rewrite <- H26.
  clear H17 H18 H23 H24 H25 H26 M0 R rd0 rs0 rt0.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.
  inversion H19.
  clear H28 H26 H25 H24 H23 H18 H4 rt0 rs0 rd0 v'0 a'0 v0 a0.
  assert (star_av a' v' ((merge Ms M_1), (R', tid_1), L) /\
              liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R', tid_1), L)).
  apply H17.
  rewrite <- H27.
  apply Next_addu.

  apply star_av_intro; auto.
  inversion_clear H4.
  unfold star_av in H18.
  unfold star_m in H18.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.

  split.
  apply resplit_AB_disjBC with Ms M_1 Ms'; auto.
  split.
  apply resplit_AB_disjUnionBCA with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I_1.
  auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R', tid_1), L)).
  unfold uni_M in H18.
  rewrite <- H18. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R', tid_1), L)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R' tid_1 L L a_1 a' G_1 H28); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, ext_R R_1 rd (R_1 rs + R_1 rt), I_1, tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  split; auto.
  split; auto.
  rewrite <- H27 in H24.
  rewrite <- H27 in H26.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H31.
  apply H31 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H32 with R_1 R' tid_1; auto.
  

 (* cons *)
  exists a'. exists v'.
  clear H4 H16 H17 H18.
  clear c0 I.
  inversion H0.
  rewrite <- H29.
  clear H4 H17 H18 H23 H24 H25 H26 H27 H28 H29.
  clear M0 C R c I k L0 M'0.
  inversion H16.
  clear H17 H18 H4 M0 R rd0.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.

  assert (M = (merge (merge Ms M_1) M_2)).
  rewrite H11.
  rewrite H12.
  apply (merge_ABC_CAB H3 H1 H13); auto.

  inversion H19.
  clear H30 H29 H28 H27 H17 rd0 v'0 a'0 v0 a0.
  assert (star_av a' v' (ext_M (ext_M (merge Ms M_1) l w0) (S l) w1, (R', tid_1), L) /\
              liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (ext_M (ext_M (merge Ms M_1) l w0) (S l) w1, (R', tid_1), L)).
  apply H18 with l w0 w1; auto.
  apply star_av_intro; auto.
  
  apply notin_merge_distr_left with M_2.
  rewrite <- H4; auto.
  apply notin_merge_distr_left with M_2.
  rewrite H4 in H26; auto.
  rewrite <- H25. auto.
  inversion_clear H17.
  unfold star_av in H27.
  unfold star_m in H27.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.


  split.
  apply resplit_AB_disjBC_cons with Ms M_1 Ms' l w0 w1; auto.
  rewrite H4 in H24. auto.
  rewrite H4 in H26. auto.

  split.
  apply resplit_AB_disjUnionBCA_cons with Ms M_1; auto.
  rewrite H4 in H24. auto.
  rewrite H4 in H26. auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I_1.
  auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R', tid_1), L)).
  unfold uni_M in H27.
  rewrite <- H27. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R', tid_1), L)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R' tid_1 L L a_1 a' G_1 H32); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, ext_R R_1 rd l, I_1, tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  split; auto.
  split; auto.
  rewrite <- H25 in H29.
  rewrite <- H25 in H31.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H35.
  apply H35 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H36 with R_1 R' tid_1; auto.

  (* free *)
  exists a'. exists v'.
  clear H4 H16 H17 H18.
  clear c0 I.
  inversion H0.
  rewrite <- H29.
  clear H4 H17 H18 H23 H24 H25 H26 H27 H28 H29.
  clear M0 C R c I k L0 M'0.
  inversion H16.
  rewrite <- H25.
  rewrite <- H25 in H16.
  rewrite <- H25 in H18.
  clear H17 H23 H24 H25 H4 R' M0 R rs0.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.

  assert (M = (merge (merge Ms M_1) M_2)).
  rewrite H11.
  rewrite H12.
  apply (merge_ABC_CAB H3 H1 H13); auto.

  inversion H19.
  clear H27 H26 H25 H24 H17 rs0 v'0 a'0 v0 a0.

  assert 
    (exists M' : Mem,
          (exists R' : RegFile,
             Next (free rs) (merge Ms M_1, R_1) (M', R') /\
             star_av a' v' (M', (R', tid_1), L) /\
             liftG a_1 G_1 a' ((merge Ms M_1), (R_1, tid_1), L) (M', (R', tid_1), L))).
  apply H23; auto.
  apply star_av_intro; auto.
  InvertAll.
  inversion H24.
  rewrite <- H31 in H24.
  rewrite <- H31 in H17.
  rewrite <- H31 in H26.
  rewrite <- H31 in H28.
  rewrite <- H30 in H24.
  rewrite <- H30 in H17.
  rewrite <- H30 in H26.
  rewrite <- H31.
  clear H31 H30 H29 H27 H25 rs0 R M0 x x0.
  unfold star_av in H17.
  unfold star_m in H17.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.


  split.
  apply resplit_AB_disjBC_free with Ms M_1 Ms' (R_1 rs); auto.

  split.
  apply resplit_AB_disjUnionBCA_free with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I_1.
  auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R_1, tid_1), L)).
  unfold uni_M in H17.
  rewrite <- H17. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R_1, tid_1), L)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R_1 tid_1 L L a_1 a' G_1 H31); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, R_1, I_1, tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H34.
  apply H34 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H35 with R_1 R_1 tid_1; auto.

  (* sw *)
  exists a'. exists v'.
  clear H4 H16 H17 H18.
  clear c0 I.
  inversion H0.
  rewrite <- H29.
  clear H4 H17 H18 H23 H24 H25 H26 H27 H28 H29.
  clear M0 C R c I k L0 M'0.
  inversion H16.
  rewrite <- H27.
  rewrite <- H27 in H16.
  rewrite <- H27 in H17.
  clear H4 H18 H23 H24 H25 H27 R' M0 R rs0 w0 rt0.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.

  (*
  assert (M = (merge (merge Ms M_1) M_2)).
  rewrite H11.
  rewrite H12.
  apply merge_ABC_CAB; auto.*)

  inversion H19.
  clear H4 H23 H29 H27 H28 H25 H24 rs0 rt0 w0 v'0 a'0 v0 a0.

  assert 
    (exists M' : Mem,
          (exists R' : RegFile,
             Next (sw rt w rs) (merge Ms M_1, R_1) (M', R') /\
             star_av a' v' (M', (R', tid_1), L) /\
             liftG a_1 G_1 a' ((merge Ms M_1), (R_1, tid_1), L) (M', (R', tid_1), L))).
  apply H18; auto.
  apply star_av_intro; auto.
  InvertAll.
  inversion H23.
  rewrite <- H33 in H23.
  rewrite <- H33 in H4.
  rewrite <- H33 in H25.
  rewrite <- H33 in H27.
  rewrite <- H32 in H23.
  rewrite <- H32 in H4.
  rewrite <- H32 in H25.
  rewrite <- H33.
  clear H33 H32 H31 H30 H29 H28 H24 rs0 w0 rt0 R M0 x x0.
  unfold star_av in H4.
  unfold star_m in H4.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.


  split.
  apply resplit_AB_disjBC_sw with Ms M_1 Ms' (R_1 rs + w) (R_1 rt); auto.

  split.
  apply resplit_AB_disjUnionBCA_sw with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I_1.
  auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R_1, tid_1), L)).
  unfold uni_M in H4.
  rewrite <- H4. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R_1, tid_1), L)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R_1 tid_1 L L a_1 a' G_1 H31); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, R_1, I_1, tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H34.
  apply H34 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H35 with R_1 R_1 tid_1; auto.

  (* lock *)
  inversion H0.
  inversion H24.

  exists a'. exists v'.
  rewrite <- H31.
  clear H4 H16 H17 H18.
  clear H23 H25 H26 H27 H28 H29 H30 H31 H32.
  clear M0 C R l0 I0 k L0.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.
  inversion H19.
  clear H4 H17 H18 H23 H25 l0 v'0 a'0 v0 a0.

  assert 
    (star_av a' v' (merge Ms M_1, (R_1, tid_1), ins_L L l tid_1) /\
        liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), ins_L L l tid_1)).
  apply H16; auto.
  apply star_av_intro; auto.
  InvertAll.
  unfold star_av in H17.
  unfold star_m in H17.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.

  split.
  apply resplit_AB_disjBC with Ms M_1 Ms'; auto.

  split.
  apply resplit_AB_disjUnionBCA with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I_1.
  auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R_1, tid_1), ins_L L l tid_1)).
  unfold uni_M in H17.
  rewrite <- H17. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R_1, tid_1), ins_L L l tid_1)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R_1 tid_1 L (ins_L L l tid_1) a_1 a' G_1 H27); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, R_1, I_1, tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H30.
  apply H30 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H31 with R_1 R_1 tid_1; auto.
  split; auto.
  assert (filter_L L tid_2 = filter_L (ins_L L l tid_1) tid_2).
  apply intertA_presv_filterB; auto.
  rewrite <- H30. auto.

  exists a_1. exists v_1.
  rewrite <- H31. rewrite <- H33.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.
  exists Ms. exists Mx. exists M_1. exists M_2.
  unfold disjUnion.
  split; auto.
  split; auto.
  split; auto.
  unfold SAGL_WFthrd.
  split; auto.

  (* unlock *)

  exists a'. exists v'.
  clear H4 H16 H17 H18 c0.
  inversion H0.
  inversion H16.
  rewrite <- H27.
  clear H4 H17 H18 H23 H24 H25 H26 H27 H28 H29 M0 C R l0 I0 k L0.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.
  inversion H19.
  clear H4 H18 H23 H24 H25 l0 v'0 a'0 v0 a0.

  assert 
    (maps_to L l tid_1 /\ star_av a' v' (merge Ms M_1, (R_1, tid_1), del_L L l) /\
        liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), del_L L l)).
  apply H17; auto.
  apply star_av_intro; auto.
  InvertAll.
  unfold star_av in H4.
  unfold star_m in H4.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.

  split.
  apply resplit_AB_disjBC with Ms M_1 Ms'; auto.

  split.
  apply resplit_AB_disjUnionBCA with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I_1.
  auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R_1, tid_1), del_L L l)).
  unfold uni_M in H4.
  rewrite <- H4. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R_1, tid_1), del_L L l)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R_1 tid_1 L (del_L L l) a_1 a' G_1 H28); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, R_1, I_1, tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H31.
  apply H31 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H32 with R_1 R_1 tid_1; auto.
  split; auto.
  assert (filter_L L tid_2 = filter_L (del_L L l) tid_2).

  apply delA_presv_filterB with tid_1; auto.
  rewrite <- H31. auto.

  (* bgtz *)
  clear H4 H16 H17 H18.
  inversion H19.
  clear H4 H16 H17 H23 H24 H25 a0 v0 a'0 v'0 rs0 f0 c0.
  inversion H0.
  inversion H16.
  rewrite <- H32.
  rewrite <- H30.
  clear H4 H16 H23 H24 H25 H27 H28 H29 H30 H31 H32.
  clear M0 C R k L0 rs0 f0 I0.
  exists a''. exists v''.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.

  assert
    ((R_1 rs > 0 ->
         star_av a'' v'' (merge Ms M_1, (R_1, tid_1), L) /\
         liftG a_1 G_1 a'' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), L)) /\
        (R_1 rs <= 0 ->
         star_av a' v' (merge Ms M_1, (R_1, tid_1), L) /\
         liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), L))).
  apply H26; auto.
  apply star_av_intro; auto.
  InvertAll.
  assert
    (star_av a'' v'' (merge Ms M_1, (R_1, tid_1), L) /\
        liftG a_1 G_1 a'' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms M_1, (R_1, tid_1), L)).
  apply H16; auto.
  clear H16 H23.
  unfold star_av in H4.
  unfold star_m in H4.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.

  split.
  apply resplit_AB_disjBC with Ms M_1 Ms'; auto.

  split.
  apply resplit_AB_disjUnionBCA with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a'').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v'' I'.
  apply SAGL_WFcdhp_WFiseq with C_1 Psi_1 f; auto.
  assert (liftG a_1 G_1 a'' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R_1, tid_1), L)).
  unfold uni_M in H16.
  rewrite <- H16. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R_1, tid_1), L)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R_1 tid_1 L L a_1 a'' G_1 H28); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a'' v'' (C_1, R_1, I', tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  apply SAGL_WFcdhp_WFiseq with C_1 Psi_1 f; auto.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H31.
  apply H31 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H32 with R_1 R_1 tid_1; auto.

  rewrite <- H32.
  rewrite <- H30.
  clear H4 H17 H23 H24 H25 H27 H28 H29 H30 H31 H32.
  clear M0 C R k L0 rs0 f0 I0.
  exists a'. exists v'.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.

  assert
    ((R_1 rs > 0 ->
         star_av a'' v'' (merge Ms M_1, (R_1, tid_1), L) /\
         liftG a_1 G_1 a'' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), L)) /\
        (R_1 rs <= 0 ->
         star_av a' v' (merge Ms M_1, (R_1, tid_1), L) /\
         liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), L))).
  apply H26; auto.
  apply star_av_intro; auto.
  InvertAll.
  assert
    (star_av a' v' (merge Ms M_1, (R_1, tid_1), L) /\
         liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), L)).
  apply H23; auto.
  clear H17 H23 H26 H18 a'' v''.
  unfold star_av in H4.
  unfold star_m in H4.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.

  split.
  apply resplit_AB_disjBC with Ms M_1 Ms'; auto.

  split.
  apply resplit_AB_disjUnionBCA with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I_1; auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R_1, tid_1), L)).
  unfold uni_M in H17.
  rewrite <- H17. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R_1, tid_1), L)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R_1 tid_1 L L a_1 a' G_1 H26); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, R_1, I_1, tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H29.
  apply H29 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H30 with R_1 R_1 tid_1; auto.

  (* jr *)
  inversion H15.
  clear H4 H16 H17 a v.
  exists a'. exists v'.
  inversion H0.
  rewrite <- H25.
  rewrite <- H27.
  clear H4 H17 H21 H22 H23 H24 H25 H26 H27 M0 C R rs1 k L0.
  unfold SAGL_WFprog.
  split; auto.
  split; auto.

  assert
    (Psi_1 (R_1 rs) = sagl_spec a' v' /\ 
     star_av a' v' (merge Ms M_1, (R_1, tid_1), L) /\
     liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L) (merge Ms M_1, (R_1, tid_1), L)
    ).
  apply H18; auto.
  apply star_av_intro; auto.
  InvertAll.
  unfold star_av in H4.
  unfold star_m in H4.
  InvertAll.
  rename x into Ms'.
  rename x0 into M_1'.
  exists Ms'.
  exists (merge M_1' M_2). exists M_1'. exists M_2.

  split.
  apply resplit_AB_disjBC with Ms M_1 Ms'; auto.

  split.
  apply resplit_AB_disjUnionBCA with Ms M_1; auto.
  rewrite H11. rewrite <- H12. unfold disjUnion. split; auto.


  assert (prec_a a').
  apply SAGL_WFiseq_preca with Psi_1 A_1 G_1 v' I'; auto.
  apply SAGL_WFcdhp_WFiseq with C_1 Psi_1 (R_1 rs); auto.
  assert (liftG a_1 G_1 a' (merge Ms M_1, (R_1, tid_1), L)
          (merge Ms' M_1', (R_1, tid_1), L)).
  unfold uni_M in H4.
  rewrite <- H4. auto.
  assert (G_1 (Ms, (R_1, tid_1), L) (Ms', (R_1, tid_1), L)).
  apply (preca_liftG_precG Ms M_1 Ms' M_1' R_1 R_1 tid_1 L L a_1 a' G_1 H26); auto.
  assert (SAGL_WFthrd Psi_1 A_1 G_1 a' v' (C_1, R_1, I', tid_1)).
  unfold SAGL_WFthrd.
  split; auto.
  apply SAGL_WFcdhp_WFiseq with C_1 Psi_1 (R_1 rs); auto.
  split; auto.
  split; auto.
  split; auto.
  split; auto.
  assert (presvA a_2 A_2).
  apply SAGL_WFthrd_aAa with Psi_2 G_2 v_2 C_2 R_2 I_2 tid_2; auto.
  unfold presvA in H29.
  apply H29 with (Ms, (R_2, tid_2), L); auto.
  unfold NI in H2.
  inversion_clear H2.
  apply H30 with R_1 R_1 tid_1; auto.
Qed.



Lemma SAGL_WFprog_commut:
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2,
    forall M T_1 T_2 L,
      SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 (M, (T_1, T_2), L)
      -> SAGL_WFprog Psi_2 Psi_1 A_2 A_1 G_2 G_1 a_2 v_2 a_1 v_1 (M, (T_2, T_1), L).
Proof.
  intros.
  induction T_1 as [X I_1]. induction X as [Y tid_1]. induction Y as [C_1 R_1].
  induction T_2 as [X I_2]. induction X as [Y tid_2]. induction Y as [C_2 R_2].
  unfold SAGL_WFprog.
  unfold SAGL_WFprog in H.
  InvertAll.
  split; auto.
  split; auto.
  rename x into Ms.
  rename x0 into Mx.
  rename x1 into M_1.
  rename x2 into M_2.
  exists Ms. exists Mx. exists M_2. exists M_1.
  split. apply disjUnion_commut; auto.
  split; auto.
  split; auto.
  unfold NI in H1.
  InvertAll.
  unfold NI.
  split; auto.
Qed.


Lemma SAGL_Presv_aux_right:
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2,
  forall M T_1 T_2 L M' T_2' L',
    SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 (M, (T_1, T_2), L)
        -> ThrdStep (M, T_2, L) (M', T_2', L')
	-> exists a_2', exists v_2',
             SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2' v_2' (M', (T_1, T_2'), L').
Proof.
  intros.
  assert (SAGL_WFprog Psi_2 Psi_1 A_2 A_1 G_2 G_1 a_2 v_2 a_1 v_1
            (M, (T_2, T_1), L)).
  apply SAGL_WFprog_commut; auto.
  assert 
    (exists a_2' : Assertion,
     (exists v_2' : Assertion,
        SAGL_WFprog Psi_2 Psi_1 A_2 A_1 G_2 G_1 a_2' v_2' a_1 v_1
          (M', (T_2', T_1), L'))).
  apply SAGL_Presv_aux_left with a_2 v_2 M T_2 L; auto.
  InvertAll.
  exists x. exists x0.
  apply SAGL_WFprog_commut; auto.
Qed.
  
Lemma SAGL_Presv :
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 P P',
    SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 P -> Step P P'
      -> exists a_1', exists v_1', exists a_2', exists v_2',
	    SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1' v_1' a_2' v_2' P'.
Proof.
  intros.
  inversion H0.
  assert
    (exists a_1', exists v_1',
             SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1' v_1' a_2 v_2 (M', (T1', T2), L')).
  apply SAGL_Presv_aux_left with a_1 v_1 M T1 L; auto.
  rewrite H2. auto.
  InvertAll.
  exists x. exists x0. exists a_2. exists v_2. auto.
  assert
    (exists a_2', exists v_2',
             SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2' v_2' (M', (T1, T2'), L')).
  apply SAGL_Presv_aux_right with a_2 v_2 M T2 L; auto.
  rewrite H2. auto.
  InvertAll.
  exists a_1. exists v_1. exists x. exists x0. auto.
Qed.


Definition SAGL_Thrd_Inv_Presv (Psi: SAGL_CdHpSpec) (M : Mem) (T: Thread) (L : LockMap) : Prop :=
    match T with
    | (C, R, Is, tid) =>
          match Is with
	  | jr rs =>
	      exists a, exists v,
		Psi (R rs) = sagl_spec a v /\ star_av a v (M, (R, tid), L)
	  | seq c Is' =>
	    match c with
	    |  bgtz rs f =>
	          exists a, exists v,
		    Psi f = sagl_spec a v /\ (R rs > 0 -> star_av a v (M, (R, tid), L))
	    |  _ => True
	    end
	  end
    end.

Lemma SAGL_presv_thrd_inv:
  forall Psi A G a v C R I tid,
    SAGL_WFthrd Psi A G a v (C, R, I, tid) ->
    forall M L,
      star_av a v (M, (R, tid), L) -> SAGL_Thrd_Inv_Presv Psi M (C, R, I, tid) L.
Proof.
  intros.
  unfold SAGL_Thrd_Inv_Presv.
  unfold SAGL_WFthrd in H.
  inversion_clear H.
  induction I.
  induction c; auto.
  clear IHI.
  inversion H2.
  inversion H6.
  exists a''.
  exists v''.
  split; auto.
  assert 
    ((R rs > 0 ->
         star_av a'' v'' (M, (R, tid), L) /\
         liftG a G a'' (M, (R, tid), L) (M, (R, tid), L)) /\
        (R rs <= 0 ->
         star_av a' v' (M, (R, tid), L) /\
         liftG a G a' (M, (R, tid), L) (M, (R, tid), L))).
  apply H17; auto.
  InvertAll.
  intro.
  assert (star_av a'' v'' (M, (R, tid), L) /\
             liftG a G a'' (M, (R, tid), L) (M, (R, tid), L)).
  apply H19; auto.
  inversion_clear H21. auto.

  inversion H2.
  exists a'. exists v'.
  assert 
    (Psi (R rs) = sagl_spec a' v' /\
       star_av a' v' (M, (R, tid), L) /\
       liftG a G a' (M, (R, tid), L) (M, (R, tid), L)).
  apply H5; auto.
  InvertAll.
  split; auto.
Qed.

Lemma SAGL_WFprog_presv_inv:
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 M T_1 T_2 L,
    SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 (M, (T_1, T_2), L) ->
      (exists M', subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_1 M' T_1 L) /\ 
      (exists M', subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_2 M' T_2 L).
Proof.
  intros.
  unfold SAGL_WFprog in H.
  induction T_1 as [X k_1]. induction X as [Y I_1]. induction Y as [C_1 R_1].
  induction T_2 as [X k_2]. induction X as [Y I_2]. induction Y as [C_2 R_2].
  InvertAll.
  rename x into Ms. rename x0 into Mx. rename x1 into M_1. rename x2 into M_2.
  unfold disjUnion in H0. unfold disjUnion in H2.
  InvertAll.
  assert (disjoint Ms M_1).
  apply disjoint_commut.
  apply disj_distr_left with M_2.
  rewrite <- H11. 
  auto.
  assert (disjoint Ms M_2).
  apply disjoint_commut.
  apply disj_distr_right with M_1.
  rewrite <- H11. auto.
  split.
  exists (merge Ms M_1).
  split.
  assert (M = merge (merge Ms M_1) M_2).
  rewrite H10.
  rewrite H11.
  apply (merge_ABC_CAB H2 H0 H12); auto.
  rewrite H13.
  apply merge_extends_map.
  apply SAGL_presv_thrd_inv with A_1 G_1 a_1 v_1; auto.
  apply star_av_intro; auto.
  exists (merge Ms M_2).
  split.
  assert (merge M_1 M_2 = merge M_2 M_1).
  apply disj_merge_commut; auto.
  rewrite H13 in H11.
  assert (M = merge (merge Ms M_2) M_1).
  rewrite H10.
  rewrite H11.
  apply (merge_ABC_CAB (disjoint_commut H2) H12 H0); auto.
  rewrite H14.
  apply merge_extends_map.
  apply SAGL_presv_thrd_inv with A_2 G_2 a_2 v_2; auto.
  apply star_av_intro; auto.  
Qed.



Definition WF_mem (M : Mem) : Prop :=
  exists ln, forall l, in_dom l M -> l < ln.

Definition WF_Mem_inP (P : Program) : Prop :=
  match P with
    (M, (T1, T2), L) => WF_mem M
  end.


Lemma WFmem_freshAddr:
  forall (x: Address) (M: Mem),
    (forall l, in_dom l M -> l < x) ->
      forall y, x <= y -> not_in_dom y M.
Proof.
  intros.
  assert (in_dom y M \/ not_in_dom y M).
  apply in_or_notin_dom.
  inversion_clear H1.
  assert (y < x). apply H; auto.
  assert (~ (x > y)).
  apply le_not_gt; auto.
  contradiction.
  auto.
Qed.


Lemma update_x_indom:
  forall M l l' x,
    in_dom l M -> in_dom l (ext_M M l' x).
Proof.
  unfold ext_M.
  intros.
  assert (sub_dom M (put beq_w M l' x)).
  apply subDom_update.
  unfold sub_dom in H0.
  apply H0; auto.
Qed.
Lemma nat_eq_or_neq:
  forall (x y : nat), x = y \/ x <> y.
Proof.
  double induction x y; auto.
  intros.
  assert (n0 = n \/ n0 <> n).
  apply H0.
  inversion_clear H1; auto.
Qed.
Lemma update_domain_change:
  forall M l l' x,
    in_dom l (ext_M M l' x) -> l = l' \/ in_dom l M.
Proof.
  intros.
  unfold ext_M in H.
  unfold put in H.
  unfold in_dom in H.
  inversion H.
  induction (beq_w l l').
  left. auto.
  right.
  unfold in_dom. auto.
Qed.
  
Lemma update_presv_WFMem :
  forall M l x,
    WF_mem M -> WF_mem (ext_M M l x).
Proof.
  unfold WF_mem.
  intros.
  inversion H.
  assert (in_dom l M \/ not_in_dom l M).
  apply in_or_notin_dom.
  inversion_clear H1.
  exists x0.
  intros.
  assert (l0 = l \/ in_dom l0 M).
  apply update_domain_change with x.
  auto.
  inversion_clear H3.
  rewrite H4. apply H0; auto. apply H0; auto.
  assert (x0 <= l \/ l < x0).
  apply le_or_lt.
  inversion_clear H1.
  exists (S l).
  intros.
  assert (l0 = l \/ in_dom l0 M).
  apply update_domain_change with x; auto.
  inversion_clear H4.
  rewrite <- H5. auto.
  assert (l0 < x0). apply H0; auto.
  omega.
  exists x0.
  intros.
  assert (l0 = l \/ in_dom l0 M).
  apply update_domain_change with x; auto.
  inversion_clear H4.
  rewrite H5. auto.
  apply H0; auto.
Qed.

Lemma del_presv_WFMem:
  forall M l, WF_mem M -> WF_mem (remove_M M l).
Proof.
  unfold WF_mem.
  intros.
  inversion H.
  exists x.
  intros.
  apply H0.
  unfold in_dom.
  unfold in_dom in H1.
  inversion H1.
  exists x0.
  unfold remove_M in H2.
  unfold remove in H2.
  induction (beq_w l0 l).
  inversion H2. auto.
Qed.

Lemma SAGL_Thrds_Presv_WFMem:
  forall M T L M' T' L', WF_mem M -> ThrdStep (M, T, L) (M', T', L') -> WF_mem M'.
Proof.
  intros.
  inversion H0.
  clear H7 H6 H5 H4 H3 H1 M'0 L0 k I C.
  inversion H2.
  rewrite <- H6. auto.
  apply update_presv_WFMem; auto.
  apply update_presv_WFMem; auto.
  apply update_presv_WFMem; auto.
  apply del_presv_WFMem; auto.
  rewrite <- H5. auto.
  rewrite <- H5. auto.
  rewrite <- H5. auto.
  rewrite <- H5. auto.
  rewrite <- H5. auto.  
  rewrite <- H5. auto.
Qed.

Lemma SAGL_Presv_WFMem:
  forall P P', WF_Mem_inP P -> Step P P' -> WF_Mem_inP P'.
Proof.
  intros.
  inversion H0.
  unfold WF_Mem_inP.
  rewrite <- H2 in H.
  unfold WF_Mem_inP in H.
  apply SAGL_Thrds_Presv_WFMem with M T1 L T1' L'; auto.
  unfold WF_Mem_inP.
  rewrite <- H2 in H.
  unfold WF_Mem_inP in H.
  apply SAGL_Thrds_Presv_WFMem with M T2 L T2' L'; auto.
Qed.

Lemma SAGL_Progress_left:
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 M T_1 T_2 L,
    WF_mem M -> SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 (M, (T_1, T_2), L)
      -> exists M', exists T_1', exists L',
	    ThrdStep (M, T_1, L) (M', T_1', L').
Proof.
  intros.
  induction T_1 as [X k_1]. induction X as [Y I_1]. induction Y as [C_1 R_1].
  induction T_2 as [X k_2]. induction X as [Y I_2]. induction Y as [C_2 R_2].
  unfold SAGL_WFprog in H0.
  InvertAll.
  rename x into Ms. rename x0 into Mx. rename x1 into M_1. rename x2 into M_2.
  unfold SAGL_WFthrd in H4.
  inversion_clear H4.
  induction I_1.
  induction c.
  exists M.
  exists (C_1, ext_R R_1 rd (R_1 rs + R_1 rt), I_1, k_1).
  exists L.
  apply ThrdStep_c.
  apply Next_addu.

  clear IHI_1.
  unfold WF_mem in H.
  inversion H.
  exists (ext_M (ext_M M x 0) (S x) 0).
  exists (C_1, ext_R R_1 rd x, I_1, k_1).
  exists L.
  apply ThrdStep_c.
  apply Next_cons.
  apply WFmem_freshAddr with x; auto.
  apply WFmem_freshAddr with x; auto.

  clear IHI_1.
  exists (remove_M M (R_1 rs)).
  exists (C_1, R_1, I_1, k_1).
  exists L.
  apply ThrdStep_c.
  apply Next_free.
  inversion H11.
  inversion H15.
  assert
    (exists M' : Mem,
          (exists R' : RegFile,
             Next (free rs) (merge Ms M_1, R_1) (M', R') /\
             star_av a' v' (M', (R', k_1), L) /\
             liftG a_1 G_1 a' (merge Ms M_1, (R_1, k_1), L) (M', (R', k_1), L))).
  apply H20; auto.
  apply star_av_intro; auto.
  unfold disjUnion in H1. unfold disjUnion in H3.
  InvertAll.
  rewrite H27 in H25.
  apply disjoint_commut.
  apply disj_distr_left with M_2; auto.
  InvertAll.
  inversion_clear H26.
  assert (M = merge (merge Ms M_1) M_2).
  unfold disjUnion in H1. unfold disjUnion in H3.
  InvertAll.  
  rewrite H30 in H29.
  rewrite H29.
  rewrite H30 in H26.
  assert (disjoint Ms M_1).
  apply disjoint_commut.
  apply disj_distr_left with M_2; auto.
  assert (disjoint Ms M_2).
  apply disjoint_commut.
  apply disj_distr_right with M_1; auto.
  apply (merge_ABC_CAB H3 H1 H31); auto.
  rewrite H26.
  apply merge_presv_in_dom; auto.

  exists (ext_M M (R_1 rs + w) (R_1 rt)).
  exists (C_1, R_1, I_1, k_1).
  exists L.
  apply ThrdStep_c.
  apply Next_sw; auto.
  clear IHI_1.
  inversion H11.
  inversion H15.
  assert 
    (exists M' : Mem,
          (exists R' : RegFile,
             Next (sw rt w rs) (merge Ms M_1, R_1) (M', R') /\
             star_av a' v' (M', (R', k_1), L) /\
             liftG a_1 G_1 a' (merge Ms M_1, (R_1, k_1), L) (M', (R', k_1), L))).
  apply H20.
  apply star_av_intro; auto.
  unfold disjUnion in H1. unfold disjUnion in H3.
  InvertAll.
  rewrite H29 in H27.
  apply disjoint_commut.
  apply disj_distr_left with M_2; auto.
  InvertAll.
  inversion_clear H28.
  unfold has_M. unfold has_M in H29.
  assert (M = merge (merge Ms M_1) M_2).
  unfold disjUnion in H1. unfold disjUnion in H3.
  InvertAll.  
  rewrite H32 in H31.
  rewrite H31.
  rewrite H32 in H28.
  assert (disjoint Ms M_1).
  apply disjoint_commut.
  apply disj_distr_left with M_2; auto.
  assert (disjoint Ms M_2).
  apply disjoint_commut.
  apply disj_distr_right with M_1; auto.
  apply (merge_ABC_CAB H3 H1 H33); auto.
  rewrite H28.
  apply merge_presv_in_dom; auto.


  assert (in_dom l L \/ not_in_dom l L).
  apply in_or_notin_dom.
  inversion_clear H4.
  exists M. exists (C_1, R_1, seq (lock l) I_1, k_1). exists L.
  apply ThrdStep_lockwait. auto. auto.
  exists M. exists (C_1, R_1, I_1, k_1). exists (ins_L L l k_1).

  apply ThrdStep_lock; auto.

  exists M. exists (C_1, R_1, I_1, k_1). exists (del_L L l).
  apply ThrdStep_unlock.
  clear IHI_1.
  inversion H11.
  inversion H15.
  assert (maps_to L l k_1 /\
           star_av a' v' (merge Ms M_1, (R_1, k_1), del_L L l) /\
           liftG a_1 G_1 a' (merge Ms M_1, (R_1, k_1), L) (merge Ms M_1, (R_1, k_1), del_L L l)).
  apply H20.
  apply star_av_intro; auto.
  unfold disjUnion in H1. unfold disjUnion in H3.
  InvertAll.
  rewrite H27 in H25.
  apply disjoint_commut.
  apply disj_distr_left with M_2; auto.
  InvertAll. auto.

  assert (R_1 rs <= 0 \/ 0 < R_1 rs).
  apply le_or_lt.
  inversion_clear H4.
  exists M. exists (C_1, R_1, I_1, k_1). exists L.
  apply ThrdStep_bgtz_b; auto.

  exists M.
  clear IHI_1.
  inversion H11.
  inversion H16.
  unfold SAGL_WFcdhp in H9.
  assert 
    (exists I : InstrSeq,
         maps_to C_1 f I /\ SAGL_WFIseq Psi_1 A_1 G_1 (sagl_spec a'' v'') I).
  apply H9; auto.
  InvertAll.
  exists (C_1, R_1, x, k_1). exists L.
  apply ThrdStep_bgtz_a.
  auto. auto.

  exists M.
  inversion H11.
  assert 
    (Psi_1 (R_1 rs) = sagl_spec a' v' /\
        star_av a' v' (merge Ms M_1, (R_1, k_1), L) /\
        liftG a_1 G_1 a' (merge Ms M_1, (R_1, k_1), L) (merge Ms M_1, (R_1, k_1), L)).
  apply H14.
  apply star_av_intro; auto.
  unfold disjUnion in H1. unfold disjUnion in H3.
  InvertAll.
  rewrite H19 in H17.
  apply disjoint_commut.
  apply disj_distr_left with M_2; auto.
  InvertAll.
  unfold SAGL_WFcdhp in H9.
  assert
    (exists I : InstrSeq,
         maps_to C_1 (R_1 rs) I /\ SAGL_WFIseq Psi_1 A_1 G_1 (sagl_spec a' v') I).
  apply H9; auto.
  InvertAll.
  exists (C_1, R_1, x, k_1).
  exists L.
  apply ThrdStep_jr. auto.
Qed.

Lemma SAGL_Progress_right:
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 M T_1 T_2 L,
    WF_mem M -> SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 (M, (T_1, T_2), L)
      -> exists M', exists T_2', exists L',
	    ThrdStep (M, T_2, L) (M', T_2', L').
Proof.
  intros.
  assert 
    (SAGL_WFprog Psi_2 Psi_1 A_2 A_1 G_2 G_1 a_2 v_2 a_1 v_1
         (M, (T_2, T_1), L)).
  apply SAGL_WFprog_commut; auto.
  apply SAGL_Progress_left with Psi_2 Psi_1 A_2 A_1 G_2 G_1 a_2 v_2 a_1 v_1 T_1; auto.
Qed.

Lemma SAGL_Progress :
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 P,
    WF_Mem_inP P -> SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 P ->
      exists P', Step P P'.
Proof.
  intros.
  induction P as [X L]. induction X as [M Y]. induction Y as [T_1 T_2].
  unfold WF_Mem_inP in H.
  assert (exists M', exists T_2', exists L',
	    ThrdStep (M, T_2, L) (M', T_2', L')).
  apply SAGL_Progress_right with Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 T_1; auto.
  InvertAll.
  exists (x, (T_1, x0), x1).
  apply Step_t2; auto.
Qed.

Inductive StepK : nat -> Program -> Program -> Prop :=
  | StepK_self : forall P, StepK 0 P P
  | StepK_step : forall n P P' P'', StepK n P' P'' -> Step P P' -> StepK (S n) P P''.


Theorem SAGL_Soundness:
  forall n,
  forall Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 P,
    SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2 P -> WF_Mem_inP P ->
                (exists P', StepK n P P') /\
	        (forall M T_1 T_2 L, 
		  StepK n P (M, (T_1, T_2), L) ->
	          (exists a_1', exists v_1', exists a_2', exists v_2',
		      SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1' v_1' a_2' v_2' (M, (T_1, T_2), L)) /\
		  (exists M', subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_1 M' T_1 L) /\
		  (exists M', subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_2 M' T_2 L)).
Proof.
  induction n.
  intros.
  split.
  exists P. apply StepK_self.
  intros.
  inversion H1.
  rewrite H4 in H.
  split.
  exists a_1. exists v_1. exists a_2. exists v_2. auto.
  apply SAGL_WFprog_presv_inv with A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2; auto.

  intros.
  split.
  assert (exists P', Step P P').
  apply SAGL_Progress with Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1 v_1 a_2 v_2; auto.
  InvertAll.
  rename x into P0.
  assert (WF_Mem_inP P0).
  apply SAGL_Presv_WFMem with P; auto.
  assert (exists a_1', exists v_1', exists a_2', exists v_2', 
	        SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1' v_1' a_2' v_2' P0).
  apply SAGL_Presv with a_1 v_1 a_2 v_2 P; auto.
  InvertAll.
  rename x into a_1'. rename x0 into v_1'. rename x1 into a_2'. rename x2 into v_2'.
  assert (
    (exists P'' : Program, StepK n P0 P'') /\
        (forall (M : Mem) (T_1 T_2 : Thread) (L : LockMap),
         StepK n P0 (M, (T_1, T_2), L) ->
         (exists a_1'' : Assertion,
            (exists v_1'' : Assertion,
               (exists a_2'' : Assertion,
                  (exists v_2'' : Assertion,
                     SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1'' v_1'' a_2''
                       v_2'' (M, (T_1, T_2), L))))) /\
         (exists M' : Map Address Word,
            subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_1 M' T_1 L) /\
         (exists M' : Map Address Word,
            subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_2 M' T_2 L))).
  apply IHn with a_1' v_1' a_2' v_2'; auto.
  InvertAll.
  exists x.
  apply StepK_step with P0; auto.

  intros.
  inversion H1.
  clear H5 H2 P0 n0.
  assert 
    (exists a_1' : Assertion,
      (exists v_1' : Assertion,
         (exists a_2' : Assertion,
            (exists v_2' : Assertion,
               SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1' v_1' a_2' v_2' P')))).
  apply SAGL_Presv with a_1 v_1 a_2 v_2 P; auto.
  InvertAll.
  rename x into a_1'. rename x0 into v_1'. rename x1 into a_2'. rename x2 into v_2'.
  assert (WF_Mem_inP P').
  apply SAGL_Presv_WFMem with P; auto.
  assert 
    ((exists P'' : Program, StepK n P' P'') /\
        (forall (M : Mem) (T_1 T_2 : Thread) (L : LockMap),
         StepK n P' (M, (T_1, T_2), L) ->
         (exists a_1' : Assertion,
            (exists v_1' : Assertion,
               (exists a_2' : Assertion,
                  (exists v_2' : Assertion,
                     SAGL_WFprog Psi_1 Psi_2 A_1 A_2 G_1 G_2 a_1' v_1' a_2'
                       v_2' (M, (T_1, T_2), L))))) /\
         (exists M' : Map Address Word,
            subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_1 M' T_1 L) /\
         (exists M' : Map Address Word,
            subseteq M' M /\ SAGL_Thrd_Inv_Presv Psi_2 M' T_2 L))).
  apply IHn with a_1' v_1' a_2' v_2'; auto.
  inversion H7. auto.
Qed.
